
/*
 ******************************************
 **    © by Widgetschmie.de 2005-2008    **
 ******************************************
 */


var userAgent = 'Fernsehen Widget 2.0 http://widgetschmie.de/widgets/Fernsehen';
var PARALLEL = true;
var PARALLEL_CAT = false;

var addedShowIDs;
var currentlyCachingDay;
var channelsToCacheAhead;
var channelsToCacheToday;				// generated from channelsToCacheAhead - must be NULL (not just empty) when we're done with the day!
var numDaysToPrecache = 6;
var cachingInProgress = false;
var needsToRecache = false;				// true when?
var redisplayAfterCachingDay = -2;		// call "updateTVListing()" again after we finish cashing data for this day
var channelsNotCached;					// a hash with an entry for every date, the date-entry holds an array of channel-names
var detailsLoadingQueue;
var detailsLoadingQueueInitialSize = 0;		// only needed for the status-display. Do _not_ rely on this one!



function hasDataForChannels(channels, day)
{
	for (var i = 0; i < channels.length; i++)
	{
		if (!FernsehPlugin.hasCachedDataForChannelAndDay(channels[i], day)) return false;
	}
	return true;
}

// dismiss the dialog and start caching
function dismissAndCacheAgain() {
	removeDialog();
	setTimeout("cacheAhead()", 10);
}




// Start caching from day 0
function cacheAhead()
{
	if(cachingInProgress)		// cacheAhead called while we're already caching - easy, call it again when we're done, it's so fast we don't need to worry
	{
		//needsToRecache = true;
		if(currentlyCachingDay <= displaySetting['day']) {
			startProgressAnim('mainProgress');
			redisplayAfterCachingDay = 1* displaySetting['day'];
		}
		return;
	}
	
	addedShowIDs = new Array();
	channelsNotCached = new Object();
	channelsToCacheAhead = new Array();
	for (key in availableChannels)
	{
		channelsToCacheAhead.push(key);
	}
	
	if (channelsToCacheAhead.length == 0) {
		return;
	}
	
	cachingInProgress = true;
	startCacheIndicator(locStr("Überprüfe Cache"));
	
	currentlyCachingDay = 0;
	// Wenn es vor zehn Uhr ist kann es sein daß noch Sendungen vom Vortag laufen,
	// sonst erscheint es so als ob auf einigen Sendern gar nichts liefe
	if ((new Date()).getHours() < 10) currentlyCachingDay = -1;
	
	setTimeout("checkChannelsForUpdates()", 10);
	doCacheAhead();
}


// does initiate the actual caching
function doCacheAhead()
{
	if(!channelsToCacheAhead) {			// should not happen, just to be sure
		//alert("doCacheAhead(): no channelsToCacheAhead");
		stopProgressAnim('mainProgress');
		return;
	}
		
	// get channels to cache today (if channelsToCacheToday is not null, doCacheAhead() was called by aheadRequestDone(), so trust that function)
	if(!channelsToCacheToday) {
		channelsToCacheToday = new Array();
		for(var i = 0; i < channelsToCacheAhead.length; i++) {
			if(!FernsehPlugin.hasCachedDataForChannelAndDay(channelsToCacheAhead[i], currentlyCachingDay)) {
				channelsToCacheToday.push(channelsToCacheAhead[i]);
			}
		}
	}
	
	if(0 == channelsToCacheToday.length) {
		setTimeout("cacheAheadNext()", 10);
		return;
	}
	
	
	// status indicators
	var daytext = (currentlyCachingDay < 0) ? locStr('Gestern') : (
					(currentlyCachingDay == 0) ? locStr('Heute') : (
						(1 == currentlyCachingDay) ? locStr('Morgen') : locStr('Tag') + ' ' + currentlyCachingDay	)	);
	startCacheIndicator(locStr("Lade") + ' ' + daytext + (PARALLEL ? '' : " (" + channelsToCacheToday[0] + ")"));
	
	if(redisplayAfterCachingDay > -2) {
		startProgressAnim('mainProgress');
	}
	
	var thatdate = new Date();
	thatdate.setTime((currentlyCachingDay*86400000)+thatdate.getTime());
	var SOAPAction = "\"http://epilot.tvstar.ch/GetProgramDataFromDateAndSender\"";
	
	// start parallel caching. On PARALLEL caching, start all channels simultaneously, only one otherwise
	var channelsToCacheForNow = PARALLEL ? channelsToCacheToday : new Array(channelsToCacheToday[0]);
	for(var c = 0; c < channelsToCacheForNow.length; c++) {
		var chnnl = availableChannels[channelsToCacheForNow[c]];
		
		var requestSend = soapRequestForChannelAndDate(channelsToCacheForNow[c], thatdate);
		var ajax = cacheAjaxRequest(SOAPAction, requestSend, aheadRequestDone, "day_of_channel#" + channelsToCacheForNow[c]);
		if(!ajax) {
			alert("FATAL: No AJAX.");
			channelNotCached(channelsToCacheForNow[c]);
			removeValueFromArray(channelsToCacheForNow[c], channelsToCacheToday);
		}
		
		// do we need to load data from a complementary channel?
		if(chnnl && chnnl.complementary_id) {
			var requestSendComplement = soapRequestForChannelAndDate(chnnl.complementary_id, thatdate);
			var ajaxComplement = cacheAjaxRequest(SOAPAction, requestSendComplement, aheadRequestDone, "complementary_for_channel#" + channelsToCacheForNow[c]);
			// silently ignore an eventually failing ajax request
		}
	}
}


function aheadRequestDone(req, context)
{
	var foo = context.split('#');
	var channel_id = foo[1];
	if(("day_of_channel" != foo[0]) && ("complementary_for_channel" != foo[0])) {
		alert("aheadRequestDone() FATAL: Unknown caching context: " + foo[0]);
		return;
	}
	
	var isComplementary = ("complementary_for_channel" == foo[0]);
	//if(!isComplementary) {
		removeValueFromArray(channel_id, channelsToCacheToday);
	//}
	var response = req.responseXML;
	
	if(!isComplementary && ((undefined == response) || (null == response))) {
		if(currentlyCachingDay >= 0) {
			channelNotCached(channel_id);
		}
	}
	
	// GOT data - the channel data?
	else {
		var programItemList = getChildNodeNamed(response.childNodes[0], "ProgramItemList");
		if(!programItemList || (null == programItemList.childNodes)) {
			if(!isComplementary && (currentlyCachingDay >= 0)) {
				channelNotCached(channel_id);
			}
		}
		
		// PROCESS the channel data
		else {
			var scheduleData = programItemList.childNodes;
			var cacheString = "";
			
			for (var i = 0; i < scheduleData.length; i++)
			{
				var thisShowChildren = scheduleData[i].childNodes;
				var showHash = new Array();
				
				for (var j = 0; j < thisShowChildren.length; j++)
				{
					var thisNode = thisShowChildren[j];
					
					var key = thisNode.tagName;
					if (thisNode.hasChildNodes())
					{
						showHash[key] = thisNode.firstChild.data;
					}
				}
				
				var programID = showHash["ProgramID"];
				var genre = showHash["Genre"].replace(/(\s+$)/g, '');
				var startTime = showHash["ProgramStartTime"];
				var endTime = showHash["ProgramEndTime"];
				var title = showHash["ProgramTitle"];
				var descriptionURL = showHash["ProgramDetailLink"];
				var imageURL = showHash["ProgramImageLink"];
				var shortDesc = showHash["ProgramDescription"];
		
				cacheString += title.replace(/_/g, "—") + "\n";
				cacheString += startTime + "\n";
				cacheString += endTime + "\n";
				cacheString += ((undefined != shortDesc) ? shortDesc : "") + "\n";
				cacheString += ((undefined != descriptionURL) ? descriptionURL : "") + "\n";
				cacheString += ((undefined != imageURL) ? imageURL : "") + "\n";
				cacheString += ((undefined != genre) ? genre : "") + "\n";
				cacheString += programID + "\n";
			}
			
			// SAVE data
			addedShowIDs = mergeArrays(addedShowIDs, FernsehPlugin.addShowsToChannel(cacheString, channel_id, ""+currentlyCachingDay));
		}
	}
	
	// status
	if(channelsToCacheToday && channelsToCacheToday.length) {
		var daytext = (currentlyCachingDay < 0) ? locStr('Gestern') : (
						(currentlyCachingDay == 0) ? locStr('Heute') : (
							(1 == currentlyCachingDay) ? locStr('Morgen') : locStr('Tag') + ' ' + currentlyCachingDay	)	);
		startCacheIndicator(locStr("Lade") + ' ' + daytext + " (" + (100 - Math.floor(channelsToCacheToday.length / channelsToCacheAhead.length * 100)) + "%)");
	}
	
	// all channels of today done?
	if(channelsToCacheToday && channelsToCacheToday.length < 1) {
		setTimeout("cacheAheadNext()", 10);
	}
	else if(!PARALLEL) {
		doCacheAhead();
	}
}


function channelNotCached(channel_id)
{
	if(availableChannels && availableChannels[channel_id]) {
		channelsNotCached[currentlyCachingDay] = channelsNotCached[currentlyCachingDay] ? channelsNotCached[currentlyCachingDay] : new Array();
		channelsNotCached[currentlyCachingDay].push(availableChannels[channel_id].getName());
	}
}


// initiates caching the next day after performing various cleanup/verification/GUI tasks
function cacheAheadNext()
{
	if (!weMayCache)
	{
		cachingDone();
		needsToCheckCache = true;
		return;
	}
	
	// enough data to show on the front?
	if((currentlyCachingDay >= redisplayAfterCachingDay) && (redisplayAfterCachingDay > -2))
	{
		redisplayAfterCachingDay = -2;
		stopProgressAnim('mainProgress');
		setTimeout("updateTVListing();", 10);
	}
	
	// after every day
	applyFiltersToShows(addedShowIDs);
	addedShowIDs = new Array();
	
	channelsToCacheToday = null;
	setTimeout("setupToolbarGenres();", 10);
	
	// looks like cacheAhead() was called when we were already caching. Start over.
	if(needsToRecache) {
		needsToRecache = false;
		cachingInProgress = false;
		setTimeout("cacheAhead()", 10);
	}
	
	// done caching...
	else if(currentlyCachingDay >= numDaysToPrecache) {
		if(checkExtendedDetails() > 0) {			// ...not yet
			setTimeout("loadExtendedDetails()", 10);
		}
		else {			// ...really
			// falls in der zwischenzeit eine neue anfrage kam zu cachen, den ganzen vorgang wiederholen
			// da eh nur daten geladen werden für sender für die keine daten vorliegen ist das undramatisch
			cachingDone();
		}
	}
	
	// cache next day
	else {
		// on every X day, get certain show details before continuing - cache next day when we have the details
		if((currentlyCachingDay % 2 == 0) && (checkExtendedDetails() > 0)) {
			setTimeout("loadExtendedDetails()", 10);
		}
		else {
			currentlyCachingDay++;
			setTimeout("doCacheAhead();", 10);
		}
	}
}


// checks if all movies have extended details loaded, and if not, loads them
function checkExtendedDetails()
{
	if (detailsLoadingQueue && detailsLoadingQueue.length > 0) return detailsLoadingQueue.length;

	var spielfilmID = "";
	var genreid = FernsehPlugin.genres();
	for (var i = 0; i < genreid.length; i++)
	{
		if (FernsehPlugin.nameOfGenreWithID(genreid[i]).match(/Spielfilm/))
		{
			spielfilmID = genreid[i];
			break;
		}
	}
	if ("" == spielfilmID)
	{
		alert("checkExtendedDetails(): Found no spielfilm id");
		return 0;
	}
	
	var allMovies = FernsehPlugin.showsFromGenreWithID(spielfilmID);
	detailsLoadingQueue = new Array();
	
	//FernsehPlugin.saveChanges(); // also calls "processPendingChanges" on CoreData
	
	// check for movies without details
	for(var i = 0; i < allMovies.length; i++) {
		if("0" == FernsehPlugin.hasExtendedDetailsForShowWithID(allMovies[i])) {
			/*if (indexOfValueInArray(detailsLoadingQueue, allMovies[i]) == -1)*/ detailsLoadingQueue.push(allMovies[i]);
		}
	}
	
	
	detailsLoadingQueueInitialSize = detailsLoadingQueue.length;
	
	return detailsLoadingQueue.length;
}



function loadExtendedDetails() {
	if(!detailsLoadingQueue || detailsLoadingQueue.length < 1) {
		return;
	}
	
	startCacheIndicator(locStr("Lade") + " " + locStr("Details"));
	var SOAPAction = "\"http://epilot.tvstar.ch/GetProgramDataByID\"";

	// start caching. If parallel, all details at once
	var tempDetailsLoadingQueue = PARALLEL_CAT ? detailsLoadingQueue : new Array(detailsLoadingQueue[0]);
	
	for(var c = 0; c < tempDetailsLoadingQueue.length; c++) {
		var foo = FernsehPlugin.showDetailsForID(tempDetailsLoadingQueue[c]);
		var s_id = foo[9];
		var requestSend = '<?xml version="1.0" encoding="utf-8"?><soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/"><soap:Body><GetProgramDataByID xmlns="http://epilot.tvstar.ch/"><nProgramID>' + s_id + '</nProgramID></GetProgramDataByID></soap:Body></soap:Envelope>';
		
		var ajax = cacheAjaxRequest(SOAPAction, requestSend, extendedShowDetailsLoaded, "show_details#" + tempDetailsLoadingQueue[c]);
		if(!ajax) {
			alert("FATAL: No AJAX.");
			removeValueFromArray(tempDetailsLoadingQueue[c], detailsLoadingQueue);
		}
	}
}

function extendedShowDetailsLoaded(req, context)
{
	var foo = context.split('#');
	var show_id = foo[1];
	
	removeValueFromArray(show_id, detailsLoadingQueue);
	if("show_details" != foo[0]) {
		alert("extendedShowDetailsLoaded() FATAL: Unknown caching context: " + foo[0]);
		return;
	}
	
	// got show details
	var response = req.responseXML;
	
	if((undefined == response) || (null == response)) {
		// handle error
		alert("an error occurred when loading the extended details for show " + show_id);
	}
	
	// got an answer
	var programDetailsList = getChildNodeNamed(response.childNodes[0], "ProgramRecord");
	if(!programDetailsList || (null == programDetailsList.childNodes)) {
		alert("extendedShowDetailsLoaded(): Did not get the ProgramRecord for context " + context + ", will try again on next cache check");
	}
	
	// parse program data
	else if ("0" == FernsehPlugin.hasExtendedDetailsForShowWithID(show_id)) {
		var details = programDetailsList.childNodes;
		var cacheString = "";
		var detailsHash = new Array();
		
		for (var i = 0; i < details.length; i++)
		{
			var thisNode = details[i];
				
			var key = thisNode.tagName;
			if (thisNode.hasChildNodes())
			{
				detailsHash[key] = thisNode.firstChild.data;
				//alert(key + " >> " + thisNode.firstChild.data);
			}
		}
		
		var actors = "";
		if (detailsHash['ACTOR']) actors = ""+detailsHash['ACTOR'];
		var roles = "";
		if (detailsHash['FIGUR']) roles = ""+detailsHash['FIGUR'];
		
		// inform the plugin
		if (("" != actors) && ("" != roles)) FernsehPlugin.setActorsAndRolesForShow(actors, roles, show_id);
		
		// now the year, the original title and the country
		var originalTitle = "";
		if (detailsHash['PRG_ORIGTITLE']) originalTitle = ""+detailsHash['PRG_ORIGTITLE'].replace(/_/g, "—");
		var year = "";
		if (detailsHash['PRG_APPEARANCE']) year = ""+detailsHash['PRG_APPEARANCE'];
		var country = "";
		if (detailsHash['PRG_COUNTRY']) country = ""+detailsHash['PRG_COUNTRY'];
		var stars = "";
		if (detailsHash['PRG_STARS']) stars = ""+detailsHash['PRG_STARS'];
		
		FernsehPlugin.setYearCountryOriginaltitleStars(year, country, originalTitle, stars, show_id);
	
		// PRG_REGIE
		var director = "";
		if (detailsHash['PRG_REGIE']) director = ""+detailsHash['PRG_REGIE'];
		
		FernsehPlugin.setDirectorsInShow(director, show_id);
		
		// done loading for this show. Update status
		addedShowIDs.push(show_id);
	}
	
	if(detailsLoadingQueue && detailsLoadingQueue.length) {
		startCacheIndicator(locStr("Lade") + " " + locStr("Details") + " (" + (100 - Math.floor(detailsLoadingQueue.length / detailsLoadingQueueInitialSize * 100)) + "%)");
	}
	
	// ****
	// done loading extended details for the last 2 days
	if(detailsLoadingQueue && detailsLoadingQueue.length < 1) {
		detailsLoadingQueue = null;
		//FernsehPlugin.saveChanges();
		setTimeout("cacheAheadNext()", 50);
	}
	
	// no parallel caching and still awaiting details for some shows...
	else if(!PARALLEL_CAT) {
		loadExtendedDetails();
	}
}


// finished caching
function cachingDone() {
	cachingInProgress = false;
	redisplayAfterCachingDay = -2;
	
	//alert("done caching");
	stopProgressAnim('mainProgress');
	stopCacheIndicator();
	
	FernsehPlugin.saveChanges();
	FernsehPlugin.sanityCheck();
	
	// inform about not cached channels
	if(channelsNotCached) {
		var channelsMissed = '';
		var earliestDay = -1;
		for(var day in channelsNotCached)
		{
			if(channelsNotCached[day].length > 0)
			{
				var time = new Date();
				time.setDate(time.getDate() + 1*day);
				channelsMissed += dayAndDate(time) + ": " + channelsNotCached[day].join(", ") + "<br />";
				if(-1 == earliestDay)
				{
					earliestDay = day;
				}
			}
		}
		
		if(('' != channelsMissed) && (earliestDay <= displaySetting['day']))
		{
			showDialog(locStr("Nicht alle Daten geladen"), locStr("Erneut versuchen"), dismissAndCacheAgain, locStr("OK"), blendDialogOut, channelsMissed);
		}
	}
}


// our ultimate weapon :D
function cacheAjaxRequest(SOAPAction, fullReq, handleFunction, context) {
	if(!(this instanceof cacheAjaxRequest)) {
		return new cacheAjaxRequest(SOAPAction, fullReq, handleFunction, context);
	}
	
	var req = null;
	
	// sends a request for a page and calls the handleFunction, which will get 'null' if the request was unsuccessful
	this.requestPage = function() {
		try {
			req = createXMLHttpRequest();
			req.onreadystatechange = function() {
				if(4 == req.readyState) {
					
					// NO SUCCESSFUL caching!
					if(200 != req.status) {
						cachingDone();
						needsToCheckCache = true;
						
						if(req.status >= 500) {				// Server error
							showDialog(locStr("Serverfehler") + " [" + req.status + "]", locStr("Erneut versuchen"), dismissAndCacheAgain, locStr("OK"), blendDialogOut, req.responseText);
						}
						else if(currentlyCachingDay <= displaySetting['day']) {		// no internet maybe? Only show if we have no data for the day we want to show
							showDialog(locStr("Daten nicht geladen"), locStr("Erneut versuchen"), dismissAndCacheAgain, locStr("OK"), blendDialogOut, "Request status: " + req.status);
						}
					}
					else {
						handleFunction(req, context);
					}
				}
			}
			
			req.open("POST", "http://epilot.tvstar.ch/", true);
			req.setRequestHeader("User-Agent", userAgent);
			req.setRequestHeader("Content-Type", "text/xml");
			req.setRequestHeader("SOAPAction", SOAPAction);
			req.setRequestHeader("Cache-Control", "no-cache");
			req.send(fullReq);
			return true;
		}
		
		catch(exc){
			//alert('[cacheAjaxRequest.requestPage] Error: ' + exc);
			handleFunction(null, context);
			return false;
		}
	}
	
	
	// returns a new XMLHttpRequest-Object. Needed because MSIE has another implementation
	var createXMLHttpRequest = function() {
		var request = null;
		
		if(window.XMLHttpRequest) {
			request = new XMLHttpRequest;
		}
		else {
			alert("FATAL: Could not create XMLHttpRequest!");
		}
		
		return request;
	}
	
	return this.requestPage();
}


function clearCache() {
	// Clearing the cache is a matter of fractions of a second, however, it is nice to give some feedback, so fake it
	getObj("clear_cache_button").style.opacity = 0.4;
	setTimeout('getObj("clear_cache_button").style.opacity = 1;', 500);
	FernsehPlugin.emptyCache();
	needsToCheckCache = true;
}



// returns the prepared SOAP request to fetch one day of one channel-id
function soapRequestForChannelAndDate(channel_id, date_obj) {
	var year = date_obj.getYear() + 1900;
	var month = date_obj.getMonth() + 1;
	var date = date_obj.getDate();
	
	return '<?xml version="1.0" encoding="utf-8"?><soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/"><soap:Body><GetProgramDataFromDateAndSender xmlns="http://epilot.tvstar.ch/"><nSenderID>' + channel_id + '</nSenderID><nYear>' + year + '</nYear><nMonth>' + month + '</nMonth><nDay>' + date + '</nDay></GetProgramDataFromDateAndSender></soap:Body></soap:Envelope>';
}


